%global optflags %(echo %{optflags}  | sed 's/D_FORTIFY_SOURCE=2/D_FORTIFY_SOURCE=0/')
# Need to do some black magic to build this on ETICS :-(
# i.e build not with an rpm installed torque-devel but a 
# unpacked libs in some random location.

# Add --with pbs=directory
# to look in some not nonstandard location.
# Add --with key=12345
# to set key.

%define use_pbsdir 0
%{?_with_pbs: %define use_pbsdir 1}
%{?_with_pbs:%define pbs %(set -- %{_with_pbs}; echo $1 | grep -v with | sed 's/=//')}

%define use_key 1
%{?_with_key: %define use_key 1}
%define key T1_VVM
%{?_with_key:%define key %(set -- %{_with_key}; echo $1 | grep -v with | sed 's/=//')}


Name: maui
Version: 3.3.2
Release: 36%{?dist}
Source0: http://www.clusterresources.com/downloads/maui/temp/maui-%{version}-git.tar.gz
Source1: maui-init.d.sh
Source2: maui.cfg
Source3: maui.sysconfig
# Increase the number of queues we can cope with.
Patch1: maui_max_mclass_patch
# Increase the number of queued jobs we can cope with.
Patch2: maui_max_mjobs_patch
# Increase the number of job slots we can have.
Patch4: maui_max_mres_patch
Patch6: maui_adminhost-check.patch

# Only needed if using the with-pbs option.
Patch7: maui_fix-pbs-home-configure.patch

# Increase MAX number of standing reservations.
Patch8: maui_max_sres.patch
# Increase Diagnose -f length.
Patch9: maui_buf_size.patch

# http://www.supercluster.org/pipermail/mauiusers/2009-February/003711.html
Patch10: maui.idlejobdepth.patch

# https://svnweb.cern.ch/trac/maui/ticket/1
#-Patch11: maui-3.2.6_p21-pbs-nodefile.patch

# max partitions
Patch20: maui_max_mpar.patch

# DEFAULT_RES_DEPTH & DEFAULT_IDLE_JOB_DEPTH
Patch21: maui_res_depth.patch

# use pbs_abort_connection
#Patch30: maui-3.3.2-use-pbs_abort_connection.patch

# patch for build w/ torque 4.1.4
Patch40: maui_MPBSI.c.t41patch

Summary: The Maui supercluster scheduler
License: ClusterResources 
Group: System/Daemons
BuildRoot: /var/tmp/maui-%{version}-root

%if ! %use_pbsdir
BuildRequires: libtorque-devel 
%endif

%package client
Requires: maui = %{version}-%{release}
Summary: Client for the MAUI schedular from SuperCluster.org
Group: System/Tools

%package server
Requires: maui = %{version}-%{release}
Summary: Server for the MAUI schedular from SuperCluster.org
Group: System/Tools

%package devel
Summary: Libary and header files for maui.
Group: System/Tools

%description
MAUI is the scheduler from SuperCluster.org

%description client
MAUI is the scheduler from SuperCluster.org

%description server
MAUI is the scheduler from SuperCluster.org

%description devel
MAUI is the scheduler from SuperCluster.org



%prep
%setup -q  

%patch1 -p1
%patch2 -p1
%patch4 -p1
%patch6  -p1

%if  %use_pbsdir
%patch7 -p1
%endif

%patch8 -p1
%patch9 -p1

%patch10 -p0

#-%patch11 -p1

%patch20 -p1

%patch21 -p0

#-%patch30 -p1

%patch40 -p0

%build
%if %use_pbsdir
%define pbsflags --with-pbs=%{pbs}
%else
%define pbsflags %{nil}
%endif


%if %use_key
%define keyflags --with-key=%{key}
%else
%define keyflags %{nil}
%endif

#-autoconf

%configure %{keyflags} %{pbsflags} --with-spooldir=%{_var}/spool/maui

sed -i	-e 's|@ll_definitions@||' \
	-e 's|@sdr_definitions@||' \
	-e 's|@sge_definitions@||' \
	-e 's|@lsf_definitions@||' \
	-e 's|@mx_definitions@||' \
	-e 's|@pcre_definitions@||' \
		Makefile

make 

%install
make install \
       INST_DIR=${RPM_BUILD_ROOT}%{_prefix} \
       MSCHED_HOME=${RPM_BUILD_ROOT}%{_var}/spool/maui

mkdir -p ${RPM_BUILD_ROOT}/etc/init.d/
mkdir -p ${RPM_BUILD_ROOT}/etc/sysconfig


cp %{SOURCE1} ${RPM_BUILD_ROOT}/etc/init.d/maui
chmod 0755 ${RPM_BUILD_ROOT}/etc/init.d/maui
cp %{SOURCE2} ${RPM_BUILD_ROOT}/var/spool/maui/maui.cfg
chmod 0644 ${RPM_BUILD_ROOT}/var/spool/maui/maui.cfg
cp %{SOURCE3} ${RPM_BUILD_ROOT}/etc/sysconfig/maui

%clean
rm -rf $RPM_BUILD_ROOT

%files 
%defattr(-,root,root)
%attr(0644,root,root) %config(noreplace) /var/spool/maui/maui.cfg
%attr(0600,root,root) %config(noreplace) /var/spool/maui/maui-private.cfg

%files client
%attr(0755,root,root) /usr/bin/*

%files server
%defattr(-,root,root)
%attr(0755,root,root) /etc/init.d/maui
%attr(0755,root,root) /usr/sbin/maui
%dir /var/spool/maui/stats
%dir /var/spool/maui/traces
%dir /var/spool/maui/tools
%dir /var/spool/maui/spool
%config(noreplace) /etc/sysconfig/maui

%files devel
%attr(0644,root,root) /usr/include/moab.h
%attr(0644,root,root) /usr/lib/libmcom.a
%attr(0644,root,root) /usr/lib/libmoab.a

%post server
if [ "$1" = "1" ] ; then
    /sbin/chkconfig --add maui
    /sbin/chkconfig maui on
else
    /sbin/service maui status > /dev/null 2>&1
    if [ "$?" = "0" ] ; then
      /sbin/service maui stop
      sleep 3
      /sbin/service maui start
    fi
fi

%preun server
if [ "$1" = "0" ] ; then
   # We are removing the last version of the package.
   /sbin/service maui stop >& /dev/null
   /sbin/chkconfig maui off
   /sbin/chkconfig --del maui 
fi



%changelog
* Tue Feb 15 2011 Christos Triantafyllidis <ctria@grid.auth.gr> 3.3-4
- Decreased -D_FORTIFY_SOURCE level to 0
  https://svnweb.cern.ch/trac/maui/ticket/2

* Fri Feb 4 2011 Christos Triantafyllidis <ctria@grid.auth.gr> 3.3-3
- Decreased -D_FORTIFY_SOURCE level from 2 to 1
  https://svnweb.cern.ch/trac/maui/ticket/2

* Mon Nov 29 2010 Steve Traylen  <steve.traylen@cern.ch> - 3.3-1
- Add maui-3.2.6_p21-pbs-nodefile.patch
  https://svnweb.cern.ch/trac/maui/ticket/1

* Fri Apr 23 2010 Steve Traylen  <steve.traylen@cern.ch>
- New upstream 3.3
- Add maui.idlejobdepth.patch patch.
- Adapt to build against EPEL's torque.
* Fri Feb 20 2009 Steve Traylen  <steve.traylen@cern.ch>
- Release: 3.2.6p21-snap.1234905291.3.%osVersion
* Fri Oct 24 2008 Steve Traylen <steve.traylen@cern.ch>
- Release: 3.2.6p21-snap.1224706197.1.%osVersion
* Fri Oct 10 2008 Steve Traylen <steve.traylen@cern.ch>
- Release: 3.2.6p20-snap.1212617145.12.%osVersion
  for the benefit of ETICS, no change.
* Thu Oct 9 2008 Steve Traylen <steve.traylen@cern.ch>
- Release: 3.2.6p20-snap.1212617145.11.%osVersion
- Consitant naming. 
- Release: 3.2.6p20-snap.1212617145.3.%osVersion
  Build against Torque 2.3.3.
* Wed Sep 24 2008 Steve Traylen <steve.traylen@cern.ch>
- Release: 3.2.6p20-snap.1212617145.2.%osVersion
- Add patch maui_buf_size.patch
  Increases the buffer size for "diagnose -f"
  Current patches applied: maui_max_mres_patch , Increase number of job slots.
                           maui_max_mclass_patch, Increase number of queues supported.
                           maui_max_mjobs_patch,  Increase number of jobs supported.
                           adminhost-check.patch, Improve access control checks.
                           maui_buf_size.patch,   Increase lenght of "diagnose -f"


* Thu Jun 19 2008 Steve Traylen <steve.traylen@cern.ch>
Increse to snapshot version 13.2.6p20-212617145
* Mon Mar 17 2008 Steve Traylen <steve.traylen@cern.ch>
Increase SRES to increase maximum number of standing reservations.
* Mon Jan 21 2008 Steve Traylen <steve.traylen@cern.ch>
- Bump release for new versioning method.
- We now know that 3.2.6p19-7 < 3.2.6p20-snap.1123434343.4 < 3.2.6p20-1
* Thu Jan 17 2008 Steve Traylen <steve.traylen@cern.ch>
- Bump version for building with new torque. (Not really needed)
- Build version maui-3.2.6p19_20.snap.1182974819-6_%osVersion.
* Tue Oct 23 2007 Steve Traylen <steve.traylen@cern.ch>
- Build version maui-3.2.6p19_20.snap.1182974819-5_%osVersion.
  maui.cfg must be 644 and not 600.
* Fri Sep 21 2007 Steve Traylen <steve.traylen@cern.ch>
- Build version maui-3.2.6p19_20.snap.1182974819-4_%osVersion.
  Spec file now has support for '--with key=12345'
* Tue Sep 11 2007 Steve Traylen <steve.traylen@cern.ch>
- Build version maui-3.2.6p19_20.snap.1182974819-1_%osVersion.
  Current patches applied: maui_max_mres_patch , Increase number of job slots.
                           maui_max_mclass_patch, Increase number of queues supported.
                           maui_max_mjobs_patch,  Increase number of jobs supported.
                           adminhost-check.patch, Improve access control checks.

* Wed Mar 21 2007 Steve Traylen <steve.traylen@cern.ch>
- Build in version maui-3.2.6p19-snap.1171482917.tar.gz
  Built on torque-2.1.8-1cri_sl3/4_1st
  Current patches applied: maui_max_mres_patch , Increase number of job slots.
                           maui_max_mclass_patch, Increase number of queues supported.
                           maui_max_mjobs_patch,  Increase number of jobs supported.
                           adminhost-check.patch, Improve access control checks.
                           FSPolicy-value.patch,  FS % config does not work with out it.

* Wed Aug 30 2006 Steve Traylen <s.traylen@rl.ac.uk>
- Add restart things to %post, %pre
* Wed Nov 16 2005 Steve Traylen <s.traylen@rl.ac.uk
- First change log
- Make init.d script more LSB complient.

